<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */

	// Include meta tags
	if($enable_mobile) {
		echo '<meta name="viewport" content="width=device-width" />';
	}

	// Include CSS files
	if ($css_compression)
	{
		require_once 'lib/jsn_compression.php';
		$objJSNCompression = new JSNCompression('css', $css_compress_files, $compress_options);
		$objJSNCompression->executeCompress();
		$this->addStylesheet(JURI::root().$cache_folder.'/'.$this->template.'_css_'.$compress_options['css_active_profile'].'.php');

		// remove modal.css from header
		$header_stuff = $this->getHeadData();
		unset($header_stuff['styleSheets'][JURI::root(true).'/media/system/css/modal.css']);
		$this->setHeadData($header_stuff);
	}
	else
	{
		foreach ($css_compress_files as $key => $value)
		{
			$this->addStyleSheet($key);
		}
	}

	if ($enable_printingoptimization)
	{
		$this->addStylesheet($template_path."/css/print.css", 'text/css', 'Print');
	}

	if (!empty($missing_css_files))
	{
		foreach ($missing_css_files as $css)
		{
			echo "<!-- Custom CSS file \"$template_path/css/$css\" does not exist -->\n";
		}
	}

	if ($template_specialfont)
	{
		$specialfont_url = 'https://fonts.googleapis.com/css?family=';
		$specialfont_url .= $jsn_textstyles_config[$template_textstyle]['font-s'];
		$specialfont_url .= ($jsn_textstyles_config[$template_textstyle]['font-sw'] != '')?':'.$jsn_textstyles_config[$template_textstyle]['font-sw']:'';
		$this->addStylesheet($specialfont_url);
	}

	// Inline CSS declaration for template styling
	echo '<style type="text/css">';

	// Template desktop layout
	if(!$enable_mobile) {
		// Setup template width parameter
		$twidth = 0;
		switch ($template_width) {
			case 'narrow':
				$twidth = $narrow_width;
				break;
			case 'wide':
				$twidth = $wide_width;
				break;
			case 'float':
				$twidth = $float_width;
				break;
		}

		if ($twidth > 100) {
			echo '
		#jsn-page {
			width: '.$twidth.'px;
		}
			';
		} else {
			echo '
		#jsn-page {
			width: '.$twidth.'%;
		}
			';
		}

		// Setup width of promo area
		$tw = 100;
		if ($has_promoleft) {
			$tw -= $promo_left_width;
			echo '
		#jsn-pos-promo {
			float: right;
		}
			';
		}
		if ($has_promoright) {
			$tw -= $promo_right_width;
			echo '
		#jsn-pos-promo {
			float: left;
		}
			';
		}
		echo '
		#jsn-pos-promo-left {
			float: left;
			width: '.$promo_left_width.'%;
		}
		#jsn-pos-promo {
			width: '.($tw-$ieoffset).'%;
		}
		#jsn-pos-promo-right {
			float: right;
			width: '.$promo_right_width.'%;
		}
		';

		// Setup width of content area
		$tw = 100;
		if ($has_left) {
			$tw -= $left_width;
			echo '
		#jsn-content_inner {
			right: '.(100 - $left_width).'%;
		}
		#jsn-content_inner1 {
			left: '.(100 - $left_width).'%;
		}
			';
		}
		if ($has_right) {
			$tw -= $right_width;
			echo '
		#jsn-content_inner2 {
			left: '.(100 - $right_width).'%;
		}
		#jsn-content_inner3 {
			right: '.(100 - $right_width).'%;
		}
			';
		}

		echo '
		#jsn-leftsidecontent {
			float: left;
			width: '.$left_width.'%;
			left: -'.($tw-$ieoffset).'%;
		}
		#jsn-maincontent {
			float: left;
			width: '.($tw-$ieoffset).'%;
			left: '.(($has_left)?$left_width.'%':0).';
		}
		#jsn-rightsidecontent {
			float: right;
			width: '.$right_width.'%;
		}
		';

		$tw = 100;
		if ($has_innerleft) {
			$tw -= $innerleft_width;
		}
		if ($has_innerright) {
			$tw -= $innerright_width;
		}

		echo '
		#jsn-pos-innerleft {
			float: left;
			width: '.$innerleft_width.'%;
			left: -'.($tw-$ieoffset).'%;
		}
		#jsn-centercol {
			float: left;
			width: '.($tw-$ieoffset).'%;
			left: '.(($has_innerleft)?$innerleft_width.'%':0).';
		}
		#jsn-pos-innerright {
			float: right;
			width: '.$innerright_width.'%;
		}
		';
	}

	// Setup font regular text
	echo '
		#jsn-master.jsn-textstyle-'.$template_textstyle.' {
			font-family: '.$jsn_textstyles_config[$template_textstyle]['font-a'].';
		}
		';

	// Setup font heading and menu text
	$elements_length = count($jsn_font_b_elements);
	for($i=0;$i<$elements_length;$i++){
		echo '
		#jsn-master.jsn-textstyle-'.$template_textstyle.' '.$jsn_font_b_elements[$i].(($i < $elements_length-1)?",":' {');
	}
	echo "
			font-family: '".str_replace('+', ' ', $jsn_textstyles_config[$template_textstyle]['font-s'])."', ".$jsn_textstyles_config[$template_textstyle]['font-b'].";
		}
	";

	// Setup font size
	echo '
		#jsn-master.jsn-textstyle-'.$template_textstyle.'.jsn-textsize-'.$template_textsize.' {
			font-size: '.$jsn_textstyles_config[$template_textstyle]["size-$template_textsize"].';
		}
	';

	// Setup main menu width parameter
	if($mm_width) {
		$mm_margin = $mm_width - 1;
		echo '
		#jsn-pos-mainmenu div.jsn-modulecontainer ul.menu-mainmenu ul,
		#jsn-pos-mainmenu div.jsn-modulecontainer ul.menu-mainmenu ul li {
			width: '.$mm_width.'px;
		}
		#jsn-pos-mainmenu div.jsn-modulecontainer ul.menu-mainmenu ul ul {
		';
		if($template_direction == 'ltr'){
			echo '	margin-left: '.$mm_margin.'px;';
		}
		if($template_direction == 'rtl'){
			echo '	margin-right: '.$mm_margin.'px;';		
		}
		echo '
		}
		';
	}

	// Setup slide menu width parameter
	if($sm_width) {
		$sm_margin = $sm_width - 1;
		echo '
		div.jsn-modulecontainer ul.menu-sidemenu ul,
		div.jsn-modulecontainer ul.menu-sidemenu ul li {
			width: '.$sm_width.'px;
		}
		div.jsn-modulecontainer ul.menu-sidemenu ul ul {
		';
		if($template_direction == 'ltr'){
			echo '	margin-left: '.$sm_margin.'px;';
		}
		if($template_direction == 'rtl'){
			echo '	margin-right: '.$sm_margin.'px;';		
		}
		echo '
		}
		';
	}

	echo '</style>';
	
	if ($js_compression)
	{
		// define which files are the first
		$firstOrdering = array();
		
		if ($enable_jquery) {
			$this->addScript($jQueryURL);
			$firstOrdering[] = $jQueryURL;
		}
		
		// Compress all JS files collected
		require_once 'lib/jsn_compression.php';
		$objJSNCompression = new JSNCompression('javascript', $js_compress_files, $compress_options);
		$objJSNCompression->executeCompress();
		$compressedFileUrl = JURI::root().$cache_folder.'/'.$this->template.'_javascript_'.$compress_options['javascript_active_profile'].'.php';
		$this->addScript($compressedFileUrl);		
		$firstOrdering[] = $compressedFileUrl;

		// Push compressed js file on top
		$header_stuff = $this->getHeadData();
		$jsnutils->arrangeFileInHeadSection($header_stuff, $firstOrdering);
		$this->setHeadData($header_stuff);
	}
	else
	{
		foreach ($js_compress_files as $key => $value)
		{
			$this->addScript($key);
		}
	}

	$this->addScriptDeclaration($javascript_params);

	// Set analytics code
	if ($analytics_code_position == 0)
	{
		echo $analytics_code;
	}
?>