<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted index access' );
jimport('joomla.filesystem.file');

class JSNCompression
{
	protected $file_list 			= array();
	protected $compress_options 	= array();
	protected $processed_file_list	= array();
	protected $metadata_filename 	= '';
	protected $compress_filename 	= '';
	protected $type 				= '';
	protected $param_file_path		= '';
    protected $active_profile		= '';

	function __construct($type, $file_list, $compress_options)
	{
		$this->__set('file_list', 			$file_list);
		$this->__set('compress_options',	$compress_options);
		$this->__set('type', 				$type);
		$this->__set('metadata_filename', 	$this->compress_options['cache_path'].DS.$this->compress_options['template_name'].'_'.$type.'_metadata.json');
		$this->__set('compress_filename', 	$this->compress_options['cache_path'].DS.$this->compress_options['template_name'].'_'.$type.'_'.$this->compress_options[$type.'_active_profile'].'.php');
		$this->__set('param_file_path', 	$this->compress_options['template_abs_path'].'/params.ini');
		$this->__set('active_profile', 		$this->compress_options[$type.'_active_profile']);

		foreach ($this->file_list as $key=>$value)
		{
			$this->processed_file_list[] = $value['file_abs_path'].DS.$value['file_name'];
		}
	}
	/**
	 * Set method
	 * @param $key
	 * @param $val
	 */
	function __set($key, $val)
	{
		$this->$key = $val;
	}
	/**
	 * Check compression cache file
	 *
	 * @return boolean True will trigger compression process
	 */
	function checkCache()
	{
		// No compression file or meta data file
		if (!file_exists($this->compress_filename))
		{
			return true;
		}
		return false;
	}
	/**
	 * Compress CSS/JS file
	 */
	function process()
	{
		$compress_content 	= '';
		$css_content		= '';
		$gzip_content		= '';
		$character_escape   = array("<?php", "?>");
		switch($this->type)
		{
			case 'css':
				require_once 'compression'.DS.'jsn_css_compression.php';
				$compression_engine = new JSNCssCompression();
				foreach($this->file_list as $key => $value)
				{
					$css_content 		= file_get_contents($value['file_abs_path'].DS.$value['file_name']);
					$last_sep 			= strrpos($key, '/');
					$file_name 			= substr($key, $last_sep + 1);
					$file_url			= substr($key, 0, $last_sep);
					$file_url			= str_replace('/media/system/', '../media/system/', $file_url);
					$compress_content 	.= $compression_engine->compressCSS($css_content, $file_url, $this->compress_options['template_path']);
				}
				break;
			case 'javascript':
				$firstScript = '';
				foreach ($this->file_list as $key => $value)
				{
					if ($value['file_name'] && !isset($value['first'])) $compress_content .= file_get_contents($value['file_abs_path'].DS.$value['file_name']);
					if (isset($value['first'])) $firstScript .= file_get_contents($value['file_abs_path'].DS.$value['file_name']);
				}
				$compress_content = $firstScript . $compress_content;
				break;
		}

		$gzip_content .= '<?php ob_start ("ob_gzhandler");header("Content-type: text/'.$this->type .'; charset=UTF-8");
			header("Cache-Control: no-cache");?>/*'.$this->active_profile.'*/';
		$compress_content = $gzip_content.str_replace($character_escape, '//', $compress_content);
		JFile::write($this->compress_filename, $compress_content);
	}

	function executeCompress()
	{
		if (isset($this->type))
		{
			$this->process();
		}
	}
}