$(document).ready(function(){
	
	
		var latlng = new google.maps.LatLng(1.280332,103.822952);
		var settings = {
			zoom: 16,
			center: latlng,
			mapTypeControl: true,
			mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU},
			navigationControl: true,
			navigationControlOptions: {style: google.maps.NavigationControlStyle.SMALL},
			mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		
		var map = new google.maps.Map(document.getElementById("map-canvas"), settings);
		
		
		var marker = new google.maps.Marker({
		  position: latlng,
		  map: map,
		  title:"ECO World Shipping Pte Ltd."
	  	});
		
		
		$("#submitBtn").click(function(event){
			event.preventDefault();
		
			if(validateForm())
			{
				var $name			= $.trim($('#name').val());
				var $company		= $.trim($('#company').val());
				var $contact		= $.trim($('#contact').val());
				var $email			= $.trim($('#email').val());
				var $subject		= $.trim($('#subject').val());
				var $subjectLabel	= $.trim($('#subject').text());
				var $message		= $.trim($('#message').val());
				
				$('.contact-form').hide();
				
				var dataArray = { 
						name: $name, 
						company:$company, 
						contact:$contact, 
						subject:$subject,
						subjectLabel:$subjectLabel,
						email:$email, 
						message:$message 
					};

				$.ajax({
						type: "POST",
						url: "http://www.ecw.com.sg/wp-content/themes/ecoshipping/mailer/process_contact.php",
						data: dataArray,
						success: function(feedback) {
							
						  if(feedback == "success")
						  {
							  	$('.contact-message').show();
						  }
						  else
						  {
								$('.contact-message').show();
						  }
						},
						error: function( jqXHR, textStatus, errorThrown ) {
							console.log(jqXHR);
							console.log(textStatus);
							console.log(errorThrown);
						}
						
				});
			}
			else
			{
				$(".error-message").fadeIn(); 
			}
	
		});
	
	
});

function validateForm(){
	
	$('.error-message').hide();
	var _error = true;
	var _errorMessage = '';
	$(".error-message").empty();
	
	var _name			= $.trim($('#name').val());
	var _company		= $.trim($('#company').val());
	var _contact		= $.trim($('#contact').val());
	var _email			= $.trim($('#email').val());

	var _message		= $.trim($('#message').val());
	
	
	if (_name === '') 
	{  
		_errorMessage = _errorMessage + "<p>Please fill in the <b>Name</b> field.</p>";
		_error =  false; 
	}
	
	if (_company === '') 
	{  
		_errorMessage = _errorMessage + "<p>Please fill in the <b>Company</b> field.</p>";
		_error =  false; 
	} 
	
	if (_contact === '') 
	{  
		_errorMessage = _errorMessage + "<p>Please fill in the <b>Contact</b> field.</p>";
		_error =  false; 
	} 

	if (!validateEmail(_email)) 
	{  
		_errorMessage = _errorMessage + "<p><b>Email</b> is incorrect.</p>";
		_error =  false; 
	}
	
	if (_message === '') 
	{  
		_errorMessage = _errorMessage + "<p>Please fill in the <b>Message</b> field.</p>";
		_error =  false; 
	}  

	$(".error-message").html(_errorMessage);
	return _error;
}

function validateEmail(email){
	var emailRegEx = /^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$/i;
	if (email.search(emailRegEx) == -1) return false;
	else return true;
}

$(window).load(function(){
	

});